/*
 * init.h
 * Variablendeklaration aller GLOBALEN Variablen
 * Created: 24.09.2014 21:25:49
 *  Author: Hartmut_Dell
 */ 

#include <avr/io.h>

#ifndef INIT_H
#define INIT_H

#ifdef C_MAIN
#define EXTERN
#define EXTERN_INIT(x) = x
#else
#define EXTERN extern
#define EXTERN_INIT
#endif

#define MotorschutzOK				PINB & ( 1 << PINB0  )
#define Motorstoerung				PINB & ( 1 << PINB1  )
#define Diagnosetaste1				PINB & ( 1 << PINB2  )
#define Diagnosetaste2				PINB & ( 1 << PINB3  )
#define BuzzerON					PORTB |= (1<<PINB4)
#define BuzzerOFF					PORTB &= ~(1<<PINB4)


#define PowerMotorON				PORTC |= (1<<PINC0)
#define PowerMotorOFF				PORTC &= ~(1<<PINC0)
#define MotorspeedON				PORTC |= (1<<PINC1)
#define MotorspeedOFF				PORTC &= ~(1<<PINC1)
#define MotorLinksON				PORTC |= (1<<PINC2)
#define MotorLinksOFF				PORTC &= ~(1<<PINC2)
#define MotorRechtsON				PORTC |= (1<<PINC3)
#define MotorRechtsOFF				PORTC &= ~(1<<PINC3)
#define ResetMotorschutzON			PORTC |= (1<<PINC4)
#define ResetMotorschutzOFF			PORTC &= ~(1<<PINC4)
#define MotorschutzLowModeON		PORTC |= (1<<PINC5)				// 3,0 A Auslsestrom
#define MotorschutzLowModeOFF		PORTC &= ~(1<<PINC5)
#define MotorschutzHighModeON		PORTC |= (1<<PINC6)				// 4,5 A Auslsestrom
#define MotorschutzHighModeOFF		PORTC &= ~(1<<PINC6)																	
#define AccuChargerStartON			PORTC |= (1<<PINC7)
#define AccuChargerStartOFF			PORTC &= ~(1<<PINC7)										



#define IniFrontEnd					PIND & ( 1 << PIND2  )
#define IniFrontSlow				PIND & ( 1 << PIND3  )
#define IniRearEnd					PIND & ( 1 << PIND4  )
#define IniRearSlow					PIND & ( 1 << PIND5  )
#define SafetyControl				PIND & ( 1 << PIND6  )
#define MotorPuls					PIND & ( 1 << PIND7  )



EXTERN uint8_t SystemOk;
EXTERN uint8_t InitSequence;
EXTERN uint8_t DigitalInOutDefined;
EXTERN uint8_t StartComm;
EXTERN uint8_t StartSafety;
EXTERN uint8_t StartMot;
EXTERN uint8_t ZeroPosition;
EXTERN uint8_t prot_code_FAULT_receicve;
EXTERN uint8_t prot_code_FAULT_send;
EXTERN uint8_t getComm;
EXTERN uint8_t putComm;
EXTERN uint8_t batComm;

EXTERN uint8_t RedButton;
EXTERN uint8_t GreenButton;

EXTERN uint8_t chargSTART;								// indicates that the charger STARTS and Ack it with prot_charg_BUSY
EXTERN uint8_t chargSTOP;								// indicates that the charger STOPS and Ack it with prot_charg_ACK
EXTERN uint8_t chargBUSY;		                        // indicates that charging is in PROGRESS ( just reading )

// Prototype functions

void initialSequence(int);								// NOT TESTED READY 80% DONE
void iniIO(int);										// TESTED DONE OKAY
void StartCommunication(int);							// TESTED BUT RESULT NEGATIVE
void FaultHandler(int,int );							// NOT READY IMPLEMENTED AND TESTED JUST FRAME !!!!!	
void SafetyControler(int);								// NOT FULLY HARDWARE TESTED !!!!
void IniMot(int);										// TESTED DONE OKAY
void NewStart(void);									// WATCHDOG RESET !!!!!
void Communication (int,int,int);						// NOT TESTED !!!

#endif 
/* INIT_H_ */

